// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.1
// Generated from file `Clock.ice'

#include <Clock.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10501
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::Clock* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Clock* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Clock* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Clock* p)
{
    p->__decRef();
}

void
__write(::IceInternal::BasicStream* __os, const ::ClockPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
__read(::IceInternal::BasicStream* __is, ::ClockPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::Clock;
	v->__copyFrom(proxy);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::ClockPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

bool
Message::operator==(const Message& __rhs) const
{
    return !operator!=(__rhs);
}

bool
Message::operator!=(const Message& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(hostid != __rhs.hostid)
    {
	return true;
    }
    if(timestamp != __rhs.timestamp)
    {
	return true;
    }
    if(buf != __rhs.buf)
    {
	return true;
    }
    return false;
}

bool
Message::operator<(const Message& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(hostid < __rhs.hostid)
    {
	return true;
    }
    else if(__rhs.hostid < hostid)
    {
	return false;
    }
    if(timestamp < __rhs.timestamp)
    {
	return true;
    }
    else if(__rhs.timestamp < timestamp)
    {
	return false;
    }
    if(buf < __rhs.buf)
    {
	return true;
    }
    else if(__rhs.buf < buf)
    {
	return false;
    }
    return false;
}

void
Message::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(hostid);
    __os->write(timestamp);
    __os->write(buf);
}

void
Message::__read(::IceInternal::BasicStream* __is)
{
    __is->read(hostid);
    __is->read(timestamp);
    __is->read(buf);
}

void
IceProxy::Clock::tick(const ::Message& msg)
{
    tick(msg, __defaultContext());
}

void
IceProxy::Clock::tick(const ::Message& msg, const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::Clock* __del = dynamic_cast< ::IceDelegate::Clock*>(__delBase.get());
	    __del->tick(msg, __ctx);
	    return;
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __rethrowException(*__ex.get());
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

const ::std::string&
IceProxy::Clock::ice_staticId()
{
    return ::Clock::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Clock::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Clock);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Clock::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Clock);
}

bool
IceProxy::operator==(const ::IceProxy::Clock& l, const ::IceProxy::Clock& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator!=(const ::IceProxy::Clock& l, const ::IceProxy::Clock& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator<(const ::IceProxy::Clock& l, const ::IceProxy::Clock& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

void
IceDelegateM::Clock::tick(const ::Message& msg, const ::Ice::Context& __context)
{
    static const ::std::string __operation("tick");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(0), __context, __compress);
    ::IceInternal::BasicStream* __os = __out.os();
    msg.__write(__os);
    bool __ok = __out.invoke();
    try
    {
	::IceInternal::BasicStream* __is = __out.is();
	if(!__ok)
	{
	    __is->throwException();
	}
    }
    catch(const ::Ice::LocalException& __ex)
    {
	throw ::IceInternal::NonRepeatable(__ex);
    }
}

void
IceDelegateD::Clock::tick(const ::Message& msg, const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "tick", static_cast< ::Ice::OperationMode>(0), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::Clock* __servant = dynamic_cast< ::Clock*>(__direct.servant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    __servant->tick(msg, __current);
	    return;
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

const ::std::string Clock::__ids[2] =
{
    "::Clock",
    "::Ice::Object"
};

bool
Clock::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__ids, __ids + 2, _s);
}

::std::vector< ::std::string>
Clock::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__ids[0], &__ids[2]);
}

const ::std::string&
Clock::ice_id(const ::Ice::Current&) const
{
    return __ids[0];
}

const ::std::string&
Clock::ice_staticId()
{
    return __ids[0];
}

::IceInternal::DispatchStatus
Clock::___tick(::IceInternal::Incoming& __in, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __is = __in.is();
    ::Message msg;
    msg.__read(__is);
    tick(msg, __current);
    return ::IceInternal::DispatchOK;
}

::std::string Clock::__all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "tick"
};

::IceInternal::DispatchStatus
Clock::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__all, __all + 5, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __all)
    {
	case 0:
	{
	    return ___ice_id(in, current);
	}
	case 1:
	{
	    return ___ice_ids(in, current);
	}
	case 2:
	{
	    return ___ice_isA(in, current);
	}
	case 3:
	{
	    return ___ice_ping(in, current);
	}
	case 4:
	{
	    return ___tick(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Clock::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Clock::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void 
__patch__ClockPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::ClockPtr* p = static_cast< ::ClockPtr*>(__addr);
    assert(p);
    *p = ::ClockPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::Clock::ice_staticId();
	throw e;
    }
}

bool
operator==(const ::Clock& l, const ::Clock& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
operator!=(const ::Clock& l, const ::Clock& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
operator<(const ::Clock& l, const ::Clock& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
