// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#include <Ice/Ice.h>

#include <ClockI.h>

using namespace std;

extern char hostname[256];

void
ClockI::tick(const Message &msg, const Ice::Current&)
{
	static Ice::Long TickCounts = 0;
	static Ice::Int MsgCount = 0;

	//cout << msg.hostid << hostname << endl;
	if(msg.hostid == hostname)
	{
		TickCounts += IceUtil::Time::now().toMicroSeconds() - msg.timestamp;
		MsgCount++;

		if(MsgCount == 100)
		{
			//print delta time
			cout << "Delay for " << MsgCount << " counts: " << TickCounts/1000.0f << " ms, Delay/count: " << ((Ice::Double)TickCounts/(Ice::Double)MsgCount)/1000.0f << " ms" << endl;
			MsgCount = 0;
			TickCounts = 0;
		}
	}
}
