// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.1
// Generated from file `Clock.ice'

#ifndef __Clock_h__
#define __Clock_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10501
#       error Ice version mismatch!
#   endif
#endif

namespace IceProxy
{

class Clock;
bool operator==(const Clock&, const Clock&);
bool operator!=(const Clock&, const Clock&);
bool operator<(const Clock&, const Clock&);

}

class Clock;
bool operator==(const Clock&, const Clock&);
bool operator!=(const Clock&, const Clock&);
bool operator<(const Clock&, const Clock&);

namespace IceInternal
{

void incRef(::Clock*);
void decRef(::Clock*);

void incRef(::IceProxy::Clock*);
void decRef(::IceProxy::Clock*);

}

typedef ::IceInternal::Handle< ::Clock> ClockPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Clock> ClockPrx;

void __write(::IceInternal::BasicStream*, const ClockPrx&);
void __read(::IceInternal::BasicStream*, ClockPrx&);
void __write(::IceInternal::BasicStream*, const ClockPtr&);
void __read(::IceInternal::BasicStream*, ClockPtr&);
void __patch__ClockPtr(void*, ::Ice::ObjectPtr&);

typedef ::std::vector< ::Ice::Byte> xbuffer;

struct Message
{
    ::std::string hostid;

    ::Ice::Long timestamp;

    ::xbuffer buf;

    bool operator==(const Message&) const;
    bool operator!=(const Message&) const;
    bool operator<(const Message&) const;

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

namespace IceProxy
{

class Clock : virtual public ::IceProxy::Ice::Object
{
public:

    void tick(const ::Message&);
    void tick(const ::Message&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

namespace IceDelegate
{

class Clock : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void tick(const ::Message&, const ::Ice::Context&) = 0;
};

}

namespace IceDelegateM
{

class Clock : virtual public ::IceDelegate::Clock,
	      virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void tick(const ::Message&, const ::Ice::Context&);
};

}

namespace IceDelegateD
{

class Clock : virtual public ::IceDelegate::Clock,
	      virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void tick(const ::Message&, const ::Ice::Context&);
};

}

class Clock : virtual public ::Ice::Object
{
public:

    static const ::std::string __ids[2];
    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void tick(const ::Message&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___tick(::IceInternal::Incoming&, const ::Ice::Current&);

    static ::std::string __all[5];
    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
};

void __patch__ClockPtr(void*, ::Ice::ObjectPtr&);

#endif
